//
// Created by Falko Alrik Schmidt on 11.01.24.
//

#include "Ulm_ADXL343.h"

Ulm_ADXL343::Ulm_ADXL343(int32_t sensorId, TwoWire *wireBus) : Adafruit_ADXL343(sensorId, wireBus) {
    // Nothing more to do here.
}

bool Ulm_ADXL343::begin() {
    if(!Adafruit_ADXL343::begin(ADXL343_ADDRESS)) {
        return false;
    }
    this->setRange(ADXL343_RANGE_2_G);
    this->setDataRate(ADXL343_DATARATE_1_56_HZ);
    return true;
}

bool Ulm_ADXL343::sample(Ulm_ADXL343_Sample &sample) {

    // Read out sensor.
    sensors_event_t event;
    bool success = this->getEvent(&event);

    // Set values.
    sample.accelerationX = event.acceleration.x;
    sample.accelerationY = event.acceleration.y;
    sample.accelerationZ = event.acceleration.z;

    // Return, if read values are correct.
    return success;
}
