//
// Created by Falko Alrik Schmidt on 19.09.23.
//

#include "Ulm_DS18B20.h"

Ulm_DS18B20::Ulm_DS18B20(uint8_t pin) : DallasTemperature() {
    this->oneWire = OneWire(pin);       // This is to not use heap.
    this->setOneWire(&(this->oneWire)); // This is to not use heap.
    this->setResolution(12);            // Highest resolution. Conversion time = 750 ms max.
    this->setWaitForConversion(false);  // Async mode (non-blocking).
}

bool Ulm_DS18B20::begin() {
    DallasTemperature::begin();
    return this->getDeviceCount() == 1;
}

bool Ulm_DS18B20::sample(float &t) {
    // Request sample from sensor.
    this->requestTemperaturesByIndex(0);

    // Fetch sample
    const float temperature = this->getTempCByIndex(0);

    // Set temperature to given value and validate.
    t = temperature;
    return t != DEVICE_DISCONNECTED_C;
}
