//
// Created by Falko Alrik Schmidt on 26.09.23.
//

#include "Ulm_MS5607.h"

Ulm_MS5607::Ulm_MS5607(int8_t address) : MS5x(&Wire) {
    this->setI2Caddr(address);
    this->setPressMbar();
    this->setTempC();
}

bool Ulm_MS5607::begin() {
    return this->connect() == 0;
}

bool Ulm_MS5607::sample(Ulm_MS5607_Sample &sample) {
    this->checkUpdates();
    sample.temperature  = static_cast<float>(MS5x::GetTemp());
    sample.pressure     = static_cast<float>(MS5x::GetPres());
    sample.altitude     = static_cast<float>(MS5x::getAltitude(true));
    return false;
}
